<script setup lang="ts">
import { ref, onMounted, reactive } from "vue";
import { useQuasar } from "quasar";
import { useRouter, useRoute } from "vue-router";
import http from "@/plugins/http";
import config from "@/app.config";

/** importType*/
import type { QTableProps } from "quasar";
import type { ResLevel } from "@/modules/01_metadata/interface/response/positionEmployee/Main";
import type { DataGroup } from "@/modules/01_metadata/interface/index/positionEmployee";
import type { FormDataLevel } from "@/modules/01_metadata/interface/request/positionEmployee";

/** importComponts*/
import DialogHeader from "@/components/DialogHeader.vue";

/** importStore*/
import { useMainOptionDataStore } from "@/modules/01_metadata/stores/main";
import { useCounterMixin } from "@/stores/mixin";

/**use*/
const $q = useQuasar();
const storeOption = useMainOptionDataStore();
const route = useRoute();
const router = useRouter();
const {
  dialogConfirm,
  showLoader,
  hideLoader,
  messageError,
  success,
  date2Thai,
  onSearchDataTable,
  dialogRemove,
} = useCounterMixin();

// Table
const rows = ref<DataGroup[]>([]); // รายการกลุ่มงาน
const rowsMain = ref<DataGroup[]>([]); // รายการกลุ่มงาน
const filter = ref<string>(""); // คำค้นหา
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    sortable: false,
    field: "no",
    headerStyle: "font-size: 14px; width:0px",
    style: "font-size: 14px",
  },
  {
    name: "posLevelName",
    align: "left",
    label: "ชั้นงาน",
    sortable: true,
    field: "posLevelName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "posLevelRank",
    align: "left",
    label: "ระดับชั้นงาน",
    sortable: true,
    field: "posLevelRank",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "posTypeName",
    align: "left",
    label: "กลุ่มงาน",
    sortable: true,
    field: "posTypeName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },

  {
    name: "posLevelAuthority",
    align: "left",
    label: "ผู้มีอำนาจสั่งบรรจุ",
    sortable: true,
    field: "posLevelAuthority",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return convertPosLevelAuthority(val);
    },
  },
  {
    name: "createdAt",
    align: "left",
    label: "วันที่สร้าง",
    sortable: true,
    field: "createdAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return date2Thai(val, false, true);
    },
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return date2Thai(val, false, true);
    },
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
]);
const visibleColumns = ref<string[]>([
  "no",
  "posLevelName",
  "posLevelRank",
  "posTypeName",
  "posLevelAuthority",
  "createdAt",
  "lastUpdatedAt",
  "lastUpdateFullName",
]);

const posTypeId = ref<string>(route.params.id.toString()); // id กลุ่มงาน
const titleName = ref<string | null>(""); // ชื่อกลุ่มงาน
const levelId = ref<string>(""); // id ระดับชั้นงานที่จะแก้ไข
const isStatusEdit = ref<boolean>(false); // สถานะแก่ไขข้อมูล
const modalDialog = ref<boolean>(false); // popup
// ฟอร์มระดับชั้นงาน
const formDataLevel = reactive<FormDataLevel>({
  posLevelName: "",
  posTypeName: "",
  posLevelAuthority: "",
  posLevelRank: null,
});

/**
 * ฟังก์ชันดึงข้อมูลรายการระดับชั้นงาน API
 * เก็บข้อมูลรรายการระดับชั้นงานไว้ใน rows.value
 */
async function fetchData() {
  rows.value = [];
  rowsMain.value = [];
  showLoader();
  await http
    .get(config.API.orgEmployeeTypeById(posTypeId.value))
    .then(async (res) => {
      titleName.value = res.data.result.posTypeName ?? null;
      formDataLevel.posTypeName = res.data.result.posTypeName;
      const lists = await res.data.result.posLevels.map((x: ResLevel) => ({
        ...x,
        posTypeName: res.data.result.posTypeName,
      }));
      rows.value = lists;
      rowsMain.value = lists;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ฟังก์ชันเปิด popup แก้ไขข้อมูลระดับชั้นงาน
 * @param data ข้อมูลระดับชั้นงานที่จะแก้ไข
 * กำหนด  isStatusEdit เป็น true และกำหนดให้ ฟอร์มข้อมูลระดับชั้นงาน เป็น ข้อมูลที่จะแก่ไข
 */
function onClickOpenDialog(
  statusEdit: boolean = false,
  data: DataGroup = {} as DataGroup,
) {
  isStatusEdit.value = statusEdit;
  modalDialog.value = true;

  if (statusEdit) {
    levelId.value = data.id;
    formDataLevel.posLevelName = data.posLevelName;
    formDataLevel.posTypeName = titleName.value;
    formDataLevel.posLevelAuthority = data.posLevelAuthority;
    formDataLevel.posLevelRank = data.posLevelRank;
  } else {
    formDataLevel.posTypeName = titleName.value ? titleName.value : "";
  }
}

/**
 * ฟังก์ชันปืด popup แก้ไขหรื่อเพิ่มข้อมูลระดับชั้นงาน
 * และกำหนดให้ ฟอร์มข้อมูลระดับชั้นงาน เป็นค่าว่าง
 */
function onClickCloseDialog() {
  modalDialog.value = false;
  formDataLevel.posLevelName = "";
  formDataLevel.posTypeName = "";
  formDataLevel.posLevelAuthority = "";
  formDataLevel.posLevelRank = null;
}

/**
 * ยืนยันการบันทึกข้อมูลรายการระดับชั้นงาน
 * ุ ถ้า dialogStatus เป็น 'false' จะทำการเพิ่มข้อมูลรายการระดับชั้นงาน ถ้าไม่จะทำการแก้ไขข้อมูล
 * เมื่อบันทึกข้อมูลเสร็จจะเรียก function fetchData() เพื่อดึงข้อมูลรายการระดับชั้นงานใหม่
 *
 */
function onSubmit() {
  dialogConfirm($q, async () => {
    showLoader();
    const body = {
      posLevelName: formDataLevel.posLevelName,
      posTypeId: posTypeId.value,
      posLevelRank: Number(formDataLevel.posLevelRank),
      posLevelAuthority: formDataLevel.posLevelAuthority,
    };
    // กำหนด Phat APi
    const url = !isStatusEdit.value
      ? config.API.orgEmployeelevel
      : config.API.orgEmployeelevelById(levelId.value);

    await http[!isStatusEdit.value ? "post" : "put"](url, body)
      .then(async () => {
        await fetchData();
        success($q, "บันทีกข้อมูลสำเร็จ");
        onClickCloseDialog();
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * ลบข้อมูลรายการระดับชั้นงาน
 * แล้ว fetch ข้อมูลรายการ ข้อมูลรายการระดับชั้นงาน ใหม่
 * @param id ข้อมูลรายการระดับชั้นงาน
 */
async function onDeleteData(id: string) {
  dialogRemove($q, async () => {
    showLoader();
    await http
      .delete(config.API.orgEmployeelevelById(id))
      .then(async () => {
        await fetchData();
        success($q, "ลบข้อมูลสำเร็จ");
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * ฟังก์ชันแปลงตำแหน่งผู้มีอำนาจ
 * @param val ค่าของผู้มีอำนาจ
 * @returns ตำแหน่งผู้มีอำนาจ
 */
function convertPosLevelAuthority(val: string) {
  const result = storeOption.posLevelAuthorityOption.find((e) => e.id === val);
  return result?.label;
}

function serchDataTable() {
  rows.value = onSearchDataTable(
    filter.value,
    rowsMain.value,
    columns.value ? columns.value : [],
  );
}

/**
 * hook ทำงานเมื่อ Components ถูกเรียกใช้งาน
 * ถ่ามี posTypeId จะดึงข้อมูลรายการระดับชั้นงาน
 */
onMounted(() => {
  posTypeId.value && fetchData();
});
</script>

<template>
  <div class="toptitle text-dark col-12 row items-center">
    <q-btn
      icon="mdi-arrow-left"
      unelevated
      round
      dense
      flat
      color="primary"
      class="q-mr-sm"
      @click="router.go(-1)"
    />
    รายการระดับชั้นงานของกลุ่มงาน{{ titleName }}
  </div>

  <q-card flat bordered>
    <div class="q-pa-md">
      <q-toolbar style="padding: 0">
        <q-btn
          flat
          round
          color="primary"
          icon="add"
          @click.stop.pervent="onClickOpenDialog()"
        >
          <q-tooltip> เพิ่มข้อมูล </q-tooltip>
        </q-btn>
        <q-space />
        <div class="row q-gutter-sm">
          <q-input
            dense
            outlined
            v-model="filter"
            placeholder="ค้นหา"
            @keydown.enter.prevent="serchDataTable"
          >
            <template v-slot:append>
              <q-icon name="search" />
            </template>
          </q-input>
          <q-select
            v-model="visibleColumns"
            multiple
            outlined
            dense
            options-dense
            :display-value="$q.lang.table.columns"
            emit-value
            map-options
            :options="columns"
            option-value="name"
            style="min-width: 140px"
          />
        </div>
      </q-toolbar>

      <d-table
        ref="table"
        :columns="columns"
        :rows="rows"
        row-key="name"
        flat
        bordered
        :paging="true"
        dense
        class="custom-header-table"
        :visible-columns="visibleColumns"
      >
        <template v-slot:header="props">
          <q-tr :props="props">
            <q-th auto-width />
            <q-th v-for="col in props.cols" :key="col.name" :props="props">
              <span class="text-weight-medium">{{ col.label }}</span>
            </q-th>
          </q-tr>
        </template>
        <template v-slot:body="props">
          <q-tr :props="props">
            <q-td auto-width>
              <q-btn
                color="edit"
                flat
                dense
                round
                icon="edit"
                @click.stop.pervent="onClickOpenDialog(true, props.row)"
              >
                <q-tooltip>แก้ไขข้อมูล</q-tooltip>
              </q-btn>
              <q-btn
                color="red"
                flat
                dense
                round
                icon="delete"
                @click.stop.prevent="onDeleteData(props.row.id)"
              >
                <q-tooltip>ลบข้อมูล</q-tooltip>
              </q-btn>
            </q-td>
            <q-td v-for="(col, index) in props.cols" :key="col.id">
              <div v-if="col.name == 'no'">
                {{ props.rowIndex + 1 }}
              </div>
              <div v-else>
                {{ col.value ?? "-" }}
              </div>
            </q-td>
          </q-tr>
        </template>
      </d-table>
    </div>
  </q-card>

  <q-dialog v-model="modalDialog" class="dialog" persistent>
    <q-card style="width: 350px">
      <q-form greedy @submit.prevent @validation-success="onSubmit">
        <q-card-section class="flex justify-between" style="padding: 0">
          <DialogHeader
            :tittle="isStatusEdit ? 'แก้ไขข้อมูล' : 'เพิ่มข้อมูล'"
            :close="onClickCloseDialog"
          />
        </q-card-section>

        <q-separator />
        <q-card-section class="row q-gutter-y-md">
          <div class="col-12">
            <q-input
              outlined
              ref="posLevelNameRef"
              v-model="formDataLevel.posLevelName"
              label="ชั้นงาน"
              dense
              lazy-rules
              borderless
              bg-color="white"
              hide-bottom-space
              :rules="[(val:string) => !!val || 'กรุณากรอกชั้นงาน']"
              class="inputgreen"
            />
          </div>

          <div class="col-12">
            <q-select
              ref="commanderRef"
              outlined
              v-model="formDataLevel.posLevelAuthority"
              emit-value
              map-options
              :options="storeOption.posLevelAuthorityOption"
              option-value="id"
              label="ผู้มีอำนาจสั่งบรรจุ"
              dense
              lazy-rules
              borderless
              bg-color="white"
              hide-bottom-space
              :rules="[(val:string) => !!val || 'กรุณาเลือกผู้มีอำนาจสั่งบรรจุ']"
              class="inputgreen"
            />
          </div>

          <div class="col-12">
            <q-select
              ref="posTypeIdRef"
              v-model="formDataLevel.posTypeName"
              label="กลุ่มงาน"
              outlined
              dense
              bg-color="white"
              hide-bottom-space
              readonly
            />
          </div>

          <div class="col-12">
            <q-input
              outlined
              ref="posLevelNameRef"
              v-model="formDataLevel.posLevelRank"
              label="ระดับชั้นงาน"
              dense
              lazy-rules
              borderless
              bg-color="white"
              hide-bottom-space
              mask="#"
              reverse-fill-mask
              :rules="[(val:string) => !!val || 'กรุณากรอกระดับชั้นงาน']"
              class="inputgreen"
            />
          </div>
        </q-card-section>
        <q-separator />
        <q-card-actions align="right">
          <q-btn id="onSubmit" type="submit" label="บันทึก" color="public">
            <q-tooltip>บันทึกข้อมูล</q-tooltip>
          </q-btn>
        </q-card-actions>
      </q-form>
    </q-card>
  </q-dialog>
</template>

<style scoped></style>
